<template>
  <v-card
    color="background"
    :style="`background-color: ${bgColor}`"
    v-if="ldsBalance"
    class="elevation-0"
  >
    <v-card-text>
      <v-list class="pa-0" color="background">
        <asset-balance :balance="ldsBalance" />
        <v-expansion-panels accordion v-if="othersToken.length">
          <v-expansion-panel>
            <v-expansion-panel-header color="background"
              ><v-divider color="gray"
            /></v-expansion-panel-header>
            <v-expansion-panel-content color="background">
              <asset-balance
                v-for="balance in othersToken"
                :key="balance.symbol"
                :balance="balance"
              />
            </v-expansion-panel-content>
          </v-expansion-panel>
        </v-expansion-panels>
      </v-list>
      <v-container class="bg-transparent">
        <v-row dense>
          <v-col cols="12" sm="6">
            <account-deposit-modal :account="account" />
          </v-col>
          <v-col cols="12" sm="6">
            <account-withdraw-modal :account="account" />
          </v-col>
        </v-row>
      </v-container>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import Component from 'vue-class-component';
import Vue from 'vue';
import { AccountResponse } from '@/api/ledius-token';
import { Prop } from 'vue-property-decorator';
import { FormattedBalance } from '@/store/exchange/balance';
import AccountDepositModal from '@/components/account/AccountDepositModal.vue';
import AccountWithdrawModal from '@/components/account/AccountWithdrawModal.vue';
import AssetBalance from '@/components/account/AssetBalance.vue';

@Component({
  components: {
    AccountDepositModal,
    AccountWithdrawModal,
    AssetBalance
  }
})
export default class AccountBalance extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly account!: AccountResponse;

  private get bgColor(): string {
    return this.$vuetify?.theme?.themes?.dark?.background?.toString() || '#000';
  }

  private get ldsBalance(): FormattedBalance {
    return this.balances[0];
  }

  private get othersToken(): FormattedBalance[] {
    return this.balances.slice(1);
  }

  private get balances(): FormattedBalance[] {
    return this.$store.getters['exchange/balance/getBalanceForAccount'](
      this.account
    );
  }

  private async mounted(): Promise<void> {
    await this.$store.dispatch('exchange/balance/fetchBalance', this.account);
  }
}
</script>

<style scoped>
.bg-transparent {
  background-color: transparent !important;
}
</style>
